{{! This partial should be included at the top of the template file }}
<script async src="{{apple.sdk_url}}"></script>
<form id="apple_login" action="{{ base_path }}/login/apple" method="post" />
  <input name="login_challenge" type="hidden" value="{{ login_challenge }}">
  <input name="_csrf" type="hidden" value="{{ csrf_token }}">
  <input name="first_name" id="apple_first_name" type="hidden">
  <input name="last_name" id="apple_last_name" type="hidden">
  <input name="apple_id_token" id="apple_id_token" type="hidden">
  <input name="apple_auth_code" id="apple_auth_code" type="hidden">
</form>
<script type="text/javascript">
  window.onload = (function (existingOnload) {
    return function () {
      if (existingOnload) { existingOnload(); }
      AppleID.auth.init({
        clientId: "{{apple.client_id}}",
        scope: 'name email',
        redirectURI: '{{apple.redirect_url}}',
        state: '{{login_challenge}}',
        usePopup: true
      });
      document.addEventListener('AppleIDSignInOnSuccess', function (event) {
        var appleData = event.detail;
        if (appleData.user && appleData.user.name) {
          document.getElementById('apple_first_name').value = appleData.user?.name?.firstName;
          document.getElementById('apple_last_name').value = appleData.user?.name?.lastName;
        }
        document.getElementById('apple_id_token').value = appleData.authorization.id_token;
        document.getElementById('apple_auth_code').value = appleData.authorization.code;
        document.getElementById('apple_login').submit()
      });
      document.addEventListener('AppleIDSignInOnFailure', (error) => {
        console.log('error signing in with Apple:', error)
      });
    }
  })(window.onload);
</script>